import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long[] a = new long[n];
        long sum = 0;
        for (int i = 0; i < n; i++) {
            a[i] = nextLong();
            sum += a[i];
        }
        int q = nextInt();
        int cnt = 0;
        for (int i = 0; i < q; i++) {
            int t = nextInt();
            if(t == 1){
                int pos = nextInt();
                --pos;
                int x = nextInt();
                sum += (x - a[(pos + cnt) % n]);
                a[(pos + cnt) % n] = x;
                out.println(sum);
            }
            if(t == 2){
                int k = nextInt();
                cnt += n - k;
                out.println(sum);
            }
        }
        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}