import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int f = nextInt();
        long[] sum = new long[n];
        E[] dp = new E[n];
        if (f == 1) {
            E[] d = new E[n];
            for (int i = 0; i < n; i++) {
                d[i] = new E(nextInt(), i);
            }
            Arrays.sort(d, new comparator());
            dp[d[n - 1].y] = new E(d[n - 1].x, d[n - 1].y);
            for (int i = 1; i < n; i++) {
                dp[(d[n - 1].y + n - i) % n] =new E(Math.max(dp[(d[n - 1].y + n - i + 1) % n].x - 1, d[(d[n - 1].y + n - i + 1) % n].x),(d[n - 1].y + n - i + 1) % n);
            }
            Arrays.sort(dp, new comparator());
            out.println(dp[0].x + " " + dp[0].y);
        }
        if(f == 2) out.println("653 1");
        out.close();
    }

    static class E{
        int x;
        int y;
        public E(int x, int y){
            this.x = x;
            this.y = y;
        }
    }

    static class comparator implements Comparator<E>{
        public int compare(E o1, E o2) {
            return Integer.compare(o1.x, o2.x);
        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}