import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int t = nextInt();
        int n = nextInt();
        V[][] v = new V[3][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 3; j++) {
                v[j][i] = new V(nextInt(), nextInt());
            }
        }
        int[][] type = new int[3][n];
        int[] tr = new int[n];
        ArrayList<E> ans = new ArrayList<>();
        if (t == 3) {
            out.println(n * (n - 1) * (n - 2) * (n - 3) / 24);
            for (int i = 0; i < n; i++) {
                for (int j = i; j < n; j++) {
                    for (int k = j; k < n; k++) {
                        for (int l = k; l < n; l++) {
                            out.println(i + " " + j + " " + k +  " " + l);
                            out.close();
                        }
                    }
                }
            }
        }
        if (t >= 4 && t <= 9) {
            d[][] s = new d[3][n];
            for (int i = 0; i < n; i++) {
                s[0][i] = new d((v[0][i].x - v[1][i].x) * (v[0][i].x - v[1][i].x) + (v[0][i].y - v[1][i].y) * (v[0][i].y - v[1][i].y), v[2][i]);
                s[1][i] = new d((v[1][i].x - v[2][i].x) * (v[1][i].x - v[2][i].x) + (v[1][i].y - v[2][i].y) * (v[1][i].y - v[2][i].y), v[0][i]);
                s[2][i] = new d((v[0][i].x - v[2][i].x) * (v[0][i].x - v[2][i].x) + (v[0][i].y - v[2][i].y) * (v[0][i].y - v[2][i].y), v[1][i]);
                Arrays.sort(s[i], new comparator());
                v[0][i] = s[2][i].b;
                v[1][i] = s[1][i].b;
                v[2][i] = s[0][i].b;
                v[1][i] = new V(v[1][i].x - v[0][i].x, v[1][i].y - v[0][i].y);
                v[2][i] = new V(v[2][i].x - v[0][i].x, v[2][i].y - v[0][i].y);
                v[0][i] = new V(0, 0);
                for (int j = 0; j < 3; j++) {
                    if(v[j][i].x >= 0 && v[j][i].y > 0) type[j][i] = 1;
                    if(v[j][i].x <= 0 && v[j][i].y > 0) type[j][i] = 2;
                    if(v[j][i].x < 0 && v[j][i].y <= 0) type[j][i] = 3;
                    if(v[j][i].x > 0 && v[j][i].y <= 0) type[j][i] = 0;
                }
                if((type[1][i] + 1) % 4 == type[2][i] % 4) tr[i] = 1;
                else tr[i] = 0;
                s[0][i] = new d(s[0][i].a, v[2][i]);
                s[1][i] = new d(s[1][i].a, v[1][i]);
                s[2][i] = new d(s[2][i].a, v[0][i]);

            }
            for (int i = 0; i < n; i++) {
                for (int j = i; j < n; j++) {
                    for (int k = j; k < n; k++) {
                        for (int l = k; l < n; l++) {
                            if (s[0][i].a == s[0][j].a && s[0][i].a == s[0][k].a && s[0][i].a == s[0][l].a &&
                                    s[1][i].a == s[1][j].a && s[1][i].a == s[1][k].a && s[1][i].a == s[1][l].a &&
                                    s[2][i].a == s[2][j].a && s[2][i].a == s[2][k].a && s[2][i].a == s[2][l].a &&
                                    (tr[i] + tr[j] + tr[k] + tr[l]) % 2 == 0) {
                                ans.add(new E(i, j, k, l));
                            }
                        }
                    }
                }
            }
        }
        out.println(ans.size());
        for (int i = 0; i < ans.size(); i++) {
            out.println(ans.get(i).x + " " + ans.get(i).y + " " + ans.get(i).z + " " + ans.get(i).t);
        }
        out.close();
    }

    static class comparator implements Comparator<d>{
        public int compare(d o1, d o2) {
            return Double.compare(o1.a, o2.a);
        }
    }

    static class d {
        double a;
        V b;

        public d(double a, V b) {
            this.a = a;
            this.b = b;
        }
    }

    static class E {
        int x;
        int y;
        int z;
        int t;

        public E(int x, int y, int z, int t) {
            this.x = x;
            this.y = y;
            this.z = z;
            this.t = t;
        }
    }


    static class V {
        double x;
        double y;

        public V(double x, double y) {
            this.x = x;
            this.y = y;
        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}