import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int t = nextInt();
        for (int i = 0; i < t; i++) {
            int n = nextInt();
            long a = nextInt();
            long b = nextInt();
            long ra = a % n;
            long rb = b % n;
            double x = 0;
            double Ra = ra;
            double Rb = rb;
            if (ra + rb >= n) {
                x = Ra * (Ra + 1) / (double) (2 * n) - (double) (n - 1) / 2.0 + Rb * (Rb - 1) / (double) (2 * n) - (Ra + Rb - n) * (Ra + Rb - n + 1) / (double) (2 * n);
            }
            if (ra + rb < n) {
                x = Ra * (Ra + 1) / (double) (2 * n) - (Ra + Rb) * (Ra + Rb + 1) / (double) (2 * n) + (Rb - 1) * Rb / (double) (2 * n);
            }
            out.println((long) ((double) (a * b + a + b) / (double) n + x));
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}