import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[] a = new int[n];
        int q = nextInt();
        double x = 1;
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        int[] b = new int[n];
        for (int i = 0; i < n; i++) {
            b[i] = nextInt();
        }
        Arrays.sort(a);
        Arrays.sort(b);
        int[] c = new int[q];
        double A = 1000000;
        int B, C;
        for (int i = 0; i < q; i++) {
            c[i] = nextInt();
            A = 1000000;
            B = 0;
            C = 0;
            double l = 0;
            double r = 4;
            int ans = 0;
            int cnt = 0;
            while (ans != c[i] && cnt < 200) {
                double m = (l + r) / 2;
                cnt++;
                ans = 0;
                for (int j = 0; j < n; j++) {
                    int left = -1;
                    int right = n;
                    while (left + 1 < right) {
                        int middle = (left + right) / 2;
                        if ((double) a[j] / (double) b[middle] <= m) right = middle;
                        else left = middle;
                    }
                    ans += n - right;
                }
                if (ans <= c[i]) {
                    l = m;
                } else r = m;
            }
            for (int j = 0; j < n; j++) {
                int left = -1;
                int right = n;
                while (left + 1 < right) {
                    int middle = (left + right) / 2;
                    if ((double) a[j] / (double) b[middle] <= l) right = middle;
                    else left = middle;
                }
                if (right == n) --right;
                if ((l - (double) a[j] / (double) b[right]) < A && (l - (double) a[j] / (double) b[right]) >= 0) {
                    A = l - (double) a[j] / (double) b[right];
                    B = j;
                    C = right;
                }
            }
            if(ans < c[i]){
                for (int j = 0; j < n; j++) {
                    int left = -1;
                    int right = n;
                    while (left + 1 < right) {
                        int middle = (left + right) / 2;
                        if ((double) a[j] / (double) b[middle] <= l) right = middle;
                        else left = middle;
                    }
                    if(left < 0) left++;
                    if (Math.abs(l - (double) a[j] / (double) b[left]) < A) {
                        A = Math.abs(l - (double) a[j] / (double) b[left]);
                        B = j;
                        C = left;
                    }
                }
            }
            int g = gcd(a[B], b[C]);
            out.println(a[B] / g + " " + b[C] / g);
        }
        out.close();
    }

    static int gcd(int a, int b) {
        int x = Math.max(a, b);
        int y = Math.min(a, b);
        while (y != 0) {
            int h = y;
            y = x % y;
            x = h;
        }
        return x;
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}